/****************************************************************************
 *
 *	Copyright (c) 1999-2009, Watanabe Lab, School of Media Science,
 *	Tokyo University of Technology, All rights reserved.
 *
 *	Redistribution and use in source and binary forms,
 *	with or without modification, are permitted provided that the
 *	following conditions are met:
 *
 *		- Redistributions of source code must retain the above
 *			copyright notice, this list of conditions and the
 *			following disclaimer.
 *
 *		- Redistributions in binary form must reproduce the above
 *			copyright notice, this list of conditions and the
 *			following disclaimer in the documentation and/or
 *			other materials provided with the distribution.
 *
 *		- Neither the name of the copyright holders nor the names
 *			of its contributors may be used to endorse or promote
 *			products derived from this software without specific
 *			prior written permission.
 *
 *	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *	"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *	LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *	FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *	COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *	INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 *	(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 *	SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 *	HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 *	STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
 *	IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 *	POSSIBILITY OF SUCH DAMAGE. 
 *
 ****************************************************************************/
/****************************************************************************
 *
 *	Copyright (c) 1999-2009, Watanabe Lab, School of Media Science,
 *	Tokyo University of Technology, All rights reserved.
 *
 *	本ソフトウェアおよびソースコードのライセンスは、基本的に
 *	「修正 BSD ライセンス」に従います。以下にその詳細を記します。
 *
 *	ソースコード形式かバイナリ形式か、変更するかしないかを問わず、
 *	以下の条件を満たす場合に限り、再頒布および使用が許可されます。
 *
 *	- ソースコードを再頒布する場合、上記の著作権表示、本条件一覧、
 *		および下記免責条項を含めること。
 *
 *	- バイナリ形式で再頒布する場合、頒布物に付属のドキュメント等の
 *		資料に、上記の著作権表示、本条件一覧、および下記免責条項を
 *		含めること。
 *
 *	- 書面による特別の許可なしに、本ソフトウェアから派生した製品の
 *		宣伝または販売促進に、本ソフトウェアの著作権者の名前または
 *		コントリビューターの名前を使用してはならない。
 *
 *	本ソフトウェアは、著作権者およびコントリビューターによって「現
 *	状のまま」提供されており、明示黙示を問わず、商業的な使用可能性、
 *	および特定の目的に対する適合性に関す暗黙の保証も含め、またそれ
 *	に限定されない、いかなる保証もないものとします。著作権者もコン
 *	トリビューターも、事由のいかんを問わず、損害発生の原因いかんを
 *	問わず、かつ責任の根拠が契約であるか厳格責任であるか(過失その
 *	他の)不法行為であるかを問わず、仮にそのような損害が発生する可
 *	能性を知らされていたとしても、本ソフトウェアの使用によって発生
 *	した(代替品または代用サービスの調達、使用の喪失、データの喪失、
 *	利益の喪失、業務の中断も含め、またそれに限定されない)直接損害、
 *	間接損害、偶発的な損害、特別損害、懲罰的損害、または結果損害に
 *	ついて、一切責任を負わないものとします。
 *
 ****************************************************************************/
#include <FK/Attribute.h>
#include <FK/Error.h>

using namespace std;

fk_Attribute_Data::fk_Attribute_Data(void)
{
	ItoIIndex = NULL;
	ItoIValue = NULL;

	ItoDIndex = NULL;
	ItoDValue = NULL;

	ItoSIndex = NULL;
	ItoSValue = NULL;

	StoIIndex = NULL;
	StoIValue = NULL;

	StoDIndex = NULL;
	StoDValue = NULL;

	StoSIndex = NULL;
	StoSValue = NULL;

	return;
}

fk_Attribute_Data::~fk_Attribute_Data()
{
	AttrInit();
	return;
}

void fk_Attribute_Data::AttrInit(void)
{
	delete ItoIIndex;
	delete ItoIValue;

	delete ItoDIndex;
	delete ItoDValue;

	delete ItoSIndex;
	delete ItoSValue;

	delete StoIIndex;
	delete StoIValue;

	delete StoDIndex;
	delete StoDValue;

	delete StoSIndex;
	delete StoSValue;

	ItoIIndex = NULL;
	ItoIValue = NULL;

	ItoDIndex = NULL;
	ItoDValue = NULL;

	ItoSIndex = NULL;
	ItoSValue = NULL;

	StoIIndex = NULL;
	StoIValue = NULL;

	StoDIndex = NULL;
	StoDValue = NULL;

	StoSIndex = NULL;
	StoSValue = NULL;

	return;
}

int fk_Attribute_Data::CreateNewIndexI(vector<int> *argArray, int argKey)
{
	unsigned int	i, size = argArray->size();

	for(i = 0; i < size; i++) {
		if((*argArray)[i] == FK_UNDEFINED) {
			(*argArray)[i] = argKey;
			return int(i);
		}
	}

	argArray->push_back(argKey);
	return size;
}

int fk_Attribute_Data::CreateNewIndexS(vector<string> *argArray, string argKey)
{
	unsigned int	i, size = argArray->size();

	for(i = 0; i < size; i++) {
		if((*argArray)[i] == "") {
			(*argArray)[i] = argKey;
			return int(i);
		}
	}

	argArray->push_back(argKey);
	return size;
}

int fk_Attribute_Data::GetIndexAttrII(const int Key) const
{
	unsigned int	i, size;

	if(ItoIIndex == (vector<int> *)NULL) {
		return FK_UNDEFINED;
	}

	size = ItoIIndex->size();

	for(i = 0; i < size; i++) {
		if((*ItoIIndex)[i] == Key) return int(i);
	}
	return FK_UNDEFINED;
}

int fk_Attribute_Data::GetIndexAttrID(const int Key) const
{
	unsigned int	i, size;

	if(ItoDIndex == (vector<int> *)NULL) {
		return FK_UNDEFINED;
	}

	size = ItoDIndex->size();

	for(i = 0; i < size; i++) {
		if((*ItoDIndex)[i] == Key) return int(i);
	}
	return FK_UNDEFINED;
}

int fk_Attribute_Data::GetIndexAttrIS(const int Key) const
{
	unsigned int	i, size;

	if(ItoSIndex == (vector<int> *)NULL) {
		return FK_UNDEFINED;
	}

	size = ItoSIndex->size();

	for(i = 0; i < size; i++) {
		if((*ItoSIndex)[i] == Key) return int(i);
	}
	return FK_UNDEFINED;
}

int fk_Attribute_Data::GetIndexAttrSI(const string Key) const
{
	unsigned int	i, size;

	if(StoIIndex == (vector<string> *)NULL) {
		return FK_UNDEFINED;
	}

	size = StoIIndex->size();

	for(i = 0; i < size; i++) {
		if((*StoIIndex)[i] == Key) return int(i);
	}
	return FK_UNDEFINED;
}

int fk_Attribute_Data::GetIndexAttrSD(const string Key) const
{
	unsigned int	i, size;

	if(StoDIndex == (vector<string> *)NULL) {
		return FK_UNDEFINED;
	}

	size = StoDIndex->size();

	for(i = 0; i < size; i++) {
		if((*StoDIndex)[i] == Key) return int(i);
	}
	return FK_UNDEFINED;
}

int fk_Attribute_Data::GetIndexAttrSS(const string Key) const
{
	unsigned int	i, size;

	if(StoSIndex == (vector<string> *)NULL) {
		return FK_UNDEFINED;
	}

	size = StoSIndex->size();

	for(i = 0; i < size; i++) {
		if((*StoSIndex)[i] == Key) return int(i);
	}
	return FK_UNDEFINED;
}

bool fk_Attribute_Data::ExistAttrII(const int Key) const
{
	if(GetIndexAttrII(Key) == FK_UNDEFINED) return false;
	return true;
}

bool fk_Attribute_Data::ExistAttrID(const int Key) const
{
	if(GetIndexAttrID(Key) == FK_UNDEFINED) return false;
	return true;
}

bool fk_Attribute_Data::ExistAttrIS(const int Key) const
{
	if(GetIndexAttrIS(Key) == FK_UNDEFINED) return false;
	return true;
}

bool fk_Attribute_Data::ExistAttrSI(const string Key) const
{
	if(GetIndexAttrSI(Key) == FK_UNDEFINED) return false;
	return true;
}

bool fk_Attribute_Data::ExistAttrSD(const string Key) const
{
	if(GetIndexAttrSD(Key) == FK_UNDEFINED) return false;
	return true;
}

bool fk_Attribute_Data::ExistAttrSS(const string Key) const
{
	if(GetIndexAttrSS(Key) == FK_UNDEFINED) return false;
	return true;
}

bool fk_Attribute_Data::SetAttrII(const int Key, const int Value)
{
	int		Index;

	if(Key < 0) {
		fk_PutError("fk_Attribute", "setAttrII", 1,
					"Key Value Error.");
		return false;
	}

	Index = GetIndexAttrII(Key);

	if(Index == FK_UNDEFINED) {
		if(ItoIIndex == (vector<int> *)NULL) {
			ItoIIndex = new vector<int>;
			ItoIValue = new vector<int>;
		}

		Index = CreateNewIndexI(ItoIIndex, Key);

		if(Index == (int)ItoIValue->size()) {
			ItoIValue->push_back(Value);
		} else {
			(*ItoIValue)[Index] = Value;
		}

		return false;
	} else {
		(*ItoIValue)[Index] = Value;
	}
	return true;
}

bool fk_Attribute_Data::SetAttrID(const int Key, const double Value)
{
	int		Index;

	if(Key < 0) {
		fk_PutError("fk_Attribute", "setAttrID", 1,
					"Key Value Error.");
		return false;
	}

	Index = GetIndexAttrID(Key);

	if(Index == FK_UNDEFINED) {
		if(ItoDIndex == (vector<int> *)NULL) {
			ItoDIndex = new vector<int>;
			ItoDValue = new vector<double>;
		}

		Index = CreateNewIndexI(ItoDIndex, Key);

		if(Index == (int)ItoDValue->size()) {
			ItoDValue->push_back(Value);
		} else {
			(*ItoDValue)[Index] = Value;
		}

		return false;
	} else {
		(*ItoDValue)[Index] = Value;
	}
	return true;
}

bool fk_Attribute_Data::SetAttrIS(const int Key, const string Value)
{
	int		Index;

	if(Key < 0) {
		fk_PutError("fk_Attribute", "setAttrIS", 1,
					"Key Value Error.");
		return false;
	}

	Index = GetIndexAttrIS(Key);

	if(Index == FK_UNDEFINED) {
		if(ItoSIndex == (vector<int> *)NULL) {
			ItoSIndex = new vector<int>;
			ItoSValue = new vector<string>;
		}

		Index = CreateNewIndexI(ItoSIndex, Key);

		if(Index == (int)ItoSValue->size()) {
			ItoSValue->push_back(Value);
		} else {
			(*ItoSValue)[Index] = Value;
		}

		return false;
	} else {
		(*ItoSValue)[Index] = Value;
	}
	return true;
}

bool fk_Attribute_Data::SetAttrSI(const string Key, const int Value)
{
	int		Index;

	if(Key.length() == 0) {
		fk_PutError("fk_Attribute", "setAttrSI", 1,
					"Key Value Error.");
		return false;
	}

	Index = GetIndexAttrSI(Key);

	if(Index == FK_UNDEFINED) {
		if(StoIIndex == (vector<string> *)NULL) {
			StoIIndex = new vector<string>;
			StoIValue = new vector<int>;
		}

		Index = CreateNewIndexS(StoIIndex, Key);

		if(Index == (int)StoIValue->size()) {
			StoIValue->push_back(Value);
		} else {
			(*StoIValue)[Index] = Value;
		}

		return false;
	} else {
		(*StoIValue)[Index] = Value;
	}
	return true;
}

bool fk_Attribute_Data::SetAttrSD(const string Key, const double Value)
{
	int		Index;

	if(Key.length() == 0) {
		fk_PutError("fk_Attribute", "setAttrSD", 1,
					"Key Value Error.");
		return false;
	}

	Index = GetIndexAttrSD(Key);

	if(Index == FK_UNDEFINED) {
		if(StoDIndex == (vector<string> *)NULL) {
			StoDIndex = new vector<string>;
			StoDValue = new vector<double>;
		}

		Index = CreateNewIndexS(StoDIndex, Key);

		if(Index == (int)StoDValue->size()) {
			StoDValue->push_back(Value);
		} else {
			(*StoDValue)[Index] = Value;
		}

		return false;
	} else {
		(*StoDValue)[Index] = Value;
	}
	return true;
}

bool fk_Attribute_Data::SetAttrSS(const string Key, const string Value)
{
	int		Index;

	if(Key.length() == 0) {
		fk_PutError("fk_Attribute", "setAttrSS", 1,
					"Key Value Error.");
		return false;
	}

	Index = GetIndexAttrSS(Key);

	if(Index == FK_UNDEFINED) {
		if(StoSIndex == (vector<string> *)NULL) {
			StoSIndex = new vector<string>;
			StoSValue = new vector<string>;
		}

		Index = CreateNewIndexS(StoSIndex, Key);

		if(Index == (int)StoSValue->size()) {
			StoSValue->push_back(Value);
		} else {
			(*StoSValue)[Index] = Value;
		}

		return false;
	} else {
		(*StoSValue)[Index] = Value;
	}
	return true;
}

int fk_Attribute_Data::GetAttrII(const int Key) const
{
	int		Index = GetIndexAttrII(Key);

	if(Index == FK_UNDEFINED) {
		return 0;
	} else {
		return (*ItoIValue)[Index];
	}
}

double fk_Attribute_Data::GetAttrID(const int Key) const
{
	int		Index = GetIndexAttrID(Key);

	if(Index == FK_UNDEFINED) {
		return 0.0;
	} else {
		return (*ItoDValue)[Index];
	}
}

string fk_Attribute_Data::GetAttrIS(const int Key) const
{
	int		Index = GetIndexAttrIS(Key);

	if(Index == FK_UNDEFINED) {
		return "";
	} else {
		return (*ItoSValue)[Index];
	}
}

int fk_Attribute_Data::GetAttrSI(const string Key) const
{
	int		Index = GetIndexAttrSI(Key);

	if(Index == FK_UNDEFINED) {
		return 0;
	} else {
		return (*StoIValue)[Index];
	}
}

double fk_Attribute_Data::GetAttrSD(const string Key) const
{
	int		Index = GetIndexAttrSD(Key);

	if(Index == FK_UNDEFINED) {
		return 0.0;
	} else {
		return (*StoDValue)[Index];
	}
}

string fk_Attribute_Data::GetAttrSS(const string Key) const
{
	int		Index = GetIndexAttrSS(Key);

	if(Index == FK_UNDEFINED) {
		return "";
	} else {
		return (*StoSValue)[Index];
	}
}

bool fk_Attribute_Data::DeleteAttrII(const int argKey)
{
	int		Index = GetIndexAttrII(argKey);

	if(Index != FK_UNDEFINED) {
		(*ItoIIndex)[Index] = FK_UNDEFINED;
		return true;
	}
	return false;
}

bool fk_Attribute_Data::DeleteAttrID(const int argKey)
{
	int		Index = GetIndexAttrID(argKey);

	if(Index != FK_UNDEFINED) {
		(*ItoDIndex)[Index] = FK_UNDEFINED;
		return true;
	}
	return false;
}

bool fk_Attribute_Data::DeleteAttrIS(const int argKey)
{
	int		Index = GetIndexAttrIS(argKey);

	if(Index != FK_UNDEFINED) {
		(*ItoSIndex)[Index] = FK_UNDEFINED;
		return true;
	}
	return false;
}

bool fk_Attribute_Data::DeleteAttrSI(const string argKey)
{
	int		Index = GetIndexAttrSI(argKey);

	if(Index != FK_UNDEFINED) {
		(*StoIIndex)[Index].erase();
		return true;
	}
	return false;
}

bool fk_Attribute_Data::DeleteAttrSD(const string argKey)
{
	int		Index = GetIndexAttrSD(argKey);

	if(Index != FK_UNDEFINED) {
		(*StoDIndex)[Index].erase();
		return true;
	}
	return false;
}

bool fk_Attribute_Data::DeleteAttrSS(const string argKey)
{
	int		Index = GetIndexAttrSS(argKey);

	if(Index != FK_UNDEFINED) {
		(*StoSIndex)[Index].erase();
		return true;
	}
	return false;
}

fk_Attribute::fk_Attribute(void)
{
	attr_data = (fk_Attribute_Data *)NULL;
	return;
}

fk_Attribute::~fk_Attribute()
{
	delete attr_data;
	return;
}

bool fk_Attribute::IsExistData(void) const
{
	if(attr_data == (fk_Attribute_Data *)NULL) {
		return false;
	}

	return true;
}

void fk_Attribute::AttrInit(void)
{
	if(IsExistData() == false) return;
	attr_data->AttrInit();
	return;
}

bool fk_Attribute::existAttrII(const int argKey) const
{
	if(IsExistData() == false) return false;
	return attr_data->ExistAttrII(argKey);
}

bool fk_Attribute::existAttrID(const int argKey) const
{
	if(IsExistData() == false) return false;
	return attr_data->ExistAttrID(argKey);
}

bool fk_Attribute::existAttrIS(const int argKey) const
{
	if(IsExistData() == false) return false;
	return attr_data->ExistAttrIS(argKey);
}

bool fk_Attribute::existAttrSI(const string argKey) const
{
	if(IsExistData() == false) return false;
	return attr_data->ExistAttrSI(argKey);
}

bool fk_Attribute::existAttrSD(const string argKey) const
{
	if(IsExistData() == false) return false;
	return attr_data->ExistAttrSD(argKey);
}

bool fk_Attribute::existAttrSS(const string argKey) const
{
	if(IsExistData() == false) return false;
	return attr_data->ExistAttrSS(argKey);
}

bool fk_Attribute::setAttrII(const int argKey, const int argValue)
{
	if(IsExistData() == false) {
		attr_data = new fk_Attribute_Data();
	}

	return attr_data->SetAttrII(argKey, argValue);
}

bool fk_Attribute::setAttrID(const int argKey, const double argValue)
{
	if(IsExistData() == false) {
		attr_data = new fk_Attribute_Data();
	}

	return attr_data->SetAttrID(argKey, argValue);
}

bool fk_Attribute::setAttrIS(const int argKey, const string argValue)
{
	if(IsExistData() == false) {
		attr_data = new fk_Attribute_Data();
	}

	return attr_data->SetAttrIS(argKey, argValue);
}

bool fk_Attribute::setAttrSI(const string argKey, const int argValue)
{
	if(IsExistData() == false) {
		attr_data = new fk_Attribute_Data();
	}

	return attr_data->SetAttrSI(argKey, argValue);
}

bool fk_Attribute::setAttrSD(const string argKey, const double argValue)
{
	if(IsExistData() == false) {
		attr_data = new fk_Attribute_Data();
	}

	return attr_data->SetAttrSD(argKey, argValue);
}

bool fk_Attribute::setAttrSS(const string argKey, const string argValue)
{
	if(IsExistData() == false) {
		attr_data = new fk_Attribute_Data();
	}

	return attr_data->SetAttrSS(argKey, argValue);
}

int fk_Attribute::getAttrII(const int argKey) const
{
	if(IsExistData() == false) {
		return 0;
	}
	return attr_data->GetAttrII(argKey);
}

double fk_Attribute::getAttrID(const int argKey) const
{
	if(IsExistData() == false) {
		return 0.0;
	}
	return attr_data->GetAttrID(argKey);
}

string fk_Attribute::getAttrIS(const int argKey) const
{
	if(IsExistData() == false) {
		return "";
	}
	return attr_data->GetAttrIS(argKey);
}

int fk_Attribute::getAttrSI(const string argKey) const
{
	if(IsExistData() == false) {
		return 0;
	}
	return attr_data->GetAttrSI(argKey);
}

double fk_Attribute::getAttrSD(const string argKey) const
{
	if(IsExistData() == false) {
		return 0.0;
	}
	return attr_data->GetAttrSD(argKey);
}

string fk_Attribute::getAttrSS(const string argKey) const
{
	if(IsExistData() == false) {
		return "";
	}
	return attr_data->GetAttrSS(argKey);
}

bool fk_Attribute::deleteAttrII(const int argKey)
{
	if(IsExistData() == false) {
		return false;
	}

	return attr_data->DeleteAttrII(argKey);
}


bool fk_Attribute::deleteAttrID(const int argKey)
{
	if(IsExistData() == false) {
		return false;
	}

	return attr_data->DeleteAttrID(argKey);
}


bool fk_Attribute::deleteAttrIS(const int argKey)
{
	if(IsExistData() == false) {
		return false;
	}

	return attr_data->DeleteAttrIS(argKey);
}


bool fk_Attribute::deleteAttrSI(const string argKey)
{
	if(IsExistData() == false) {
		return false;
	}

	return attr_data->DeleteAttrSI(argKey);
}

bool fk_Attribute::deleteAttrSD(const string argKey)
{
	if(IsExistData() == false) {
		return false;
	}

	return attr_data->DeleteAttrSD(argKey);
}

bool fk_Attribute::deleteAttrSS(const string argKey)
{
	if(IsExistData() == false) {
		return false;
	}

	return attr_data->DeleteAttrSS(argKey);
}
